// MeshOptimizer - Copyright (C) 2013-2019 UCLouvain-ULiege
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use, copy,
// modify, merge, publish, distribute, and/or sell copies of the
// Software, and to permit persons to whom the Software is furnished
// to do so, provided that the above copyright notice(s) and this
// permission notice appear in all copies of the Software and that
// both the above copyright notice(s) and this permission notice
// appear in supporting documentation.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT OF THIRD PARTY RIGHTS. IN NO EVENT SHALL THE
// COPYRIGHT HOLDER OR HOLDERS INCLUDED IN THIS NOTICE BE LIABLE FOR
// ANY CLAIM, OR ANY SPECIAL INDIRECT OR CONSEQUENTIAL DAMAGES, OR ANY
// DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
// WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
// ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE
// OF THIS SOFTWARE.

#ifndef _MESHOPTOBJECTIVEFUNCTION_H_
#define _MESHOPTOBJECTIVEFUNCTION_H_

#include <string>
#include <vector>
#include "ap.h"

class ObjContrib;
class Patch;

class ObjectiveFunction
  : public std::vector<ObjContrib *> // Contributions to objective function in
                                     // each pass
{
public:
  void initialize(Patch *mesh);
  std::string contribNames();
  std::string minMaxStr();
  std::vector<std::pair<double, double> > minMax();
  std::vector<std::string> names();
  void updateMinMax();
  void updateParameters();
  void updateResults();
  bool stagnated();
  bool targetReached();
  std::string failMeasures();
  std::string targetsNotReached();
  bool compute(double &obj, alglib::real_1d_array &gradObj);
};

#endif /* _MESHOPTOBJECTIVEFUNCTION_H_ */
